unit de55u1;

(*Crude program to copy 1 file in x from a folder to a second folder.

Originally written to purge accidentally created archive of 900,000
IPCam images collected at River Road, 1-16-5-16

Derives from information in http://sheepdogguides.com/lut/lt2Nb.htm

vers='21 May 16' "used in anger" successfully that date to fetch every
1000th file from a folder of 900,000 on pcTwoLan. The huge archive
arose from poor settings in IVA244 Jan-May 16. (That want was the
reason I wrote IVA244.)
(vers='21 May 16b' is just vers='21 May 16' with comments added)

*)

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls{,
  dosUnit dos needed for DosError, needed for FindFirst, FindNext error detecting,
         and for the maddeningly named TYPE "searchrec" which is DIFFERENT from
         the standard type Tsearchrec.};

const vers='21 May 16b';//(Put after "uses")

type

  { TDE55f1 }

  TDE55f1 = class(TForm)
    buQuit: TButton;
    buDoFirst: TButton;
    buDoRest: TButton;
    eKeepHowMany: TEdit;
    eSourceFolder: TEdit;
    eExtension: TEdit;
    Label1: TLabel;
    laFilesReadTxt: TLabel;
    laFileReadName: TLabel;
    laFilesCopied: TLabel;
    laKeepHowManyTxt: TLabel;
    laSourcefolderEditboxTxt: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    laDesignateExtensionTxt: TLabel;
    procedure buDoRestClick(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure buDoFirstClick(Sender: TObject);
    procedure eExtensionChange(Sender: TObject);
    procedure eKeepHowManyChange(Sender: TObject);
    procedure eSourceFolderChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { private declarations }
    bTmp,bReductionFactor:byte;//if set to 3, one file in 3 is copied.
    sSourceFolder,sDestFolder:string;//Source of files, Destination for selected
        //files. Note: Files COPIED, not MOVED, so purge source folder
        //by hand after running program, if "extras" not wanted.
    sExtension:string;//e.g. 'jpg', if only doing jpg files. BEWARE: need something,
        //or program may do things to folders, or worse, parent folders!
    srResultRecord:TSearchRec;//TSearchRec is a standard Lazarus type
    boTmp:boolean;
    wKeepHowOften:word;//set to 4 to copy one file in 4 to the "keep" folder.
    lwFilesRead,lwFilesCopied:longword;
    liTmp:longint;
    procedure FirstFile;
    procedure DoDoRest;

  public
    { public declarations }
  end;

var
  DE55f1: TDE55f1;

implementation

{$R *.lfm}

{ TDE55f1 }

procedure TDE55f1.buQuitClick(Sender: TObject);
begin
  close;
end;

procedure TDE55f1.buDoRestClick(Sender: TObject);
begin
  DoDoRest;
end;

procedure TDE55f1.DoDoRest;
//Will only work if FindFirst was done successfully previously.
//"Enable" locks on buttons are supposed to ensure this only called
//    in such circumstances.
var boDone:boolean;
begin
  buDoFirst.enabled:=false;
  buDoRest.enabled:=false;
  boDone:=false;
  repeat
     application.processmessages;//So prgm can be stopped in long run
     liTmp:=FindNext(srResultRecord);
     if lwFilesRead mod wKeepHowOften=0 then begin //copy a file
     //    showmessage('copy this one');
         //VERY CRUDE COPY...
     //   showmessage(sSourceFolder+'/'+srResultRecord.name);
     //   showmessage('C:DE55/Keep/'+srResultRecord.name);

         boTmp:=copyfile(sSourceFolder+'/'+srResultRecord.name,'C:/DE55/Keep/'+srResultRecord.name,true);
            //The "true" parameter makes the copy bear same timestamp as original
         if boTmp=false then begin
              showmessage('Problem in copy');
              boDone:=true;
              end;//boTmp was false after copy
         //END VERY CRUDE COPY
         inc(lwFilesCopied);
         laFilesCopied.caption:='Files copied: '+inttostr(lwFilesCopied);
         end;//Copy a file.
     if liTmp=0 then begin
        laFileReadName.caption:='Most recently read file/folder was:'+srResultRecord.name;
        end//no ;
      else begin
        boDone:=true;
        end;


  inc(lwFilesRead);
  laFilesReadTxt.caption:='Files read: '+inttostr(lwFilesRead);

  //if lwFilesRead=4 then boDone:=true;
  until boDone=true;
  FindClose(srResultRecord);
  showmessage('Remember: Selected filed COPIED to (dest folder). ALL originals still on drive.');
end;



procedure TDE55f1.buDoFirstClick(Sender: TObject);
begin
  FirstFile;//Done with a button because this is crude!
end;

procedure TDE55f1.eExtensionChange(Sender: TObject);
begin
  buDoRest.enabled:=false;
end;

procedure TDE55f1.eKeepHowManyChange(Sender: TObject);
begin
  bTmp:=0;
  try
     wKeepHowOften:=strtoint(eKeepHowMany.text);
     buDofirst.enabled:=true;
  except
    on Exception do begin
       buDofirst.enabled:=false;
       end;//.. what you do on exception
  end;//Try... except...
end;

procedure TDE55f1.eSourceFolderChange(Sender: TObject);
begin
  buDoRest.enabled:=false;
end;

procedure TDE55f1.FirstFile;
begin
  buDoRest.enabled:=false;
  sSourceFolder:=eSourceFolder.text;
  sExtension:=eExtension.text;
  if sExtension[1]='.' then sExtension:=copy(sExtension,2,length(sExtension)-1);
  if length(sExtension)=0 then begin
     showmessage('You must specify an extension, or program may act on folders.');
     close;
     end;

  sDestFolder:='C:/DE55/Keep';


  liTmp:=FindFirst(sSourceFolder+'/*.'+sExtension, faAnyFile, srResultRecord);
  if liTmp=0 then begin
    {See: http://lazarus-ccr.sourceforge.net/docs/rtl/sysutils/findfirst.html
      liTmp will be zero if there is no error ON A WINDOWS MACHINE, but
      -1 if no error on a Unix-like platform. Sigh.}
      laFileReadName.caption:='First file/folder found was:'+srResultRecord.name;
      buDoRest.enabled:=true;
      end// no ; here. This is end of liTmp=0...
    else begin
      showmessage('No file or folder exists matching those filters');
      FindClose(srResultRecord);
      end;//else

  //IF file found, "Do Rest" must be done, for its "FindClose".


  lwFilesRead:=1;
  laFilesReadTxt.caption:='Files read: '+inttostr(lwFilesRead);

  end;

procedure TDE55f1.FormCreate(Sender: TObject);
begin
  showmessage('Currently hard coded to send copies to C:DE55/Keep... and no'+
    ' tests made that it even exists! FIX!!');
  caption:='DE55- folder selective harvest- vers: '+vers;
  eSourceFolder.text:='C:/DE55/TestSource';
  eExtension.text:='txt';
  eKeepHowMany.text:='5';
  laFileReadName.caption:='No file read yet';
  laFilesCopied.caption:='No files copied yet';
  lwFilesCopied:=0;
  //application.title:='yy';

end;





(*
var srResultRecord:TSearchRec;

procedure FirstFile;
begin
  SetCurrentDir('C:\');
  FindFirst('*', faAnyFile, srResultRecord);
  FindClose(srResultRecord);
  end;
                       ====

  var srResultRecord:TSearchRec;

procedure FirstFile;
begin
  SetCurrentDir('C:\');
  if FindFirst('*', faAnyFile, srResultRecord) then
      showmessage('First file/folder found was:'+srResultRecord.name)
    else showmessage('No file or folder exists matching those filters');
  FindClose(srResultRecord);
  end;

  var srResultRecord:TSearchRec;
      iLoop: integer;
                    ===
  procedure ListFive;
  begin
    SetCurrentDir('C:\');
    FindFirst('*', faAnyFile, srResultRecord);
     showmessage('First file/folder found was:'+srResultRecord.name);

    for iLoop:=1 to 4 do begin
       FindNext('*', faAnyFile, srResultRecord);
       showmessage('Next file/folder found was:'+srResultRecord.name);
       end;//"for..."

    FindClose(srResultRecord);
    end;//ListFive
                 ===
    But to "do things" to the file or folder as an unopened entity, there are things like...

        CopyFile
  *)


end.

